package com.community.huiju.controller;

import com.community.commom.mode.ResponseBean;
import com.community.huiju.service.IMonitoringService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpSession;

/**
 * 监控 控制器
 * @author weiximei
 */
@RestController
@RefreshScope
@RequestMapping("/")
@Api(value = "监控 控制器", description = "监控相关的数据")
public class MonitoringController {

    @Autowired
    private IMonitoringService iMonitoringService;

    @ApiOperation(value = "获取监控列表数据",notes = "根据小区ID获取")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path",dataType = "Integer",name = "communityId",value = "小区ID")
    })
    @RequestMapping(value = "/monitoring/{communityId}",method = RequestMethod.POST)
    public ResponseBean getList(@PathVariable("communityId") Integer communityId){
        ResponseBean response = iMonitoringService.getByCommunityId(communityId);
        return response;
    }

}
