package com.community.huiju.service.impl;

import com.community.commom.constant.Constant;
import com.community.commom.utils.DateUtils;
import com.community.huiju.dao.ToBannerMapper;
import com.community.huiju.dao.TpCarouselSettingMapper;
import com.community.huiju.model.ToBanner;
import com.community.huiju.service.BannerServiceI;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author weichaochao
 * @Title: BannerServiceImpl
 * @date 2018/10/22
 */
@Service("/BannerService")
public class BannerServiceImpl implements BannerServiceI {

    @Autowired
    private ToBannerMapper toBannerMapper;

    @Autowired
    private TpCarouselSettingMapper tpCarouselSettingMapper;

    @Override
    public ToBanner viewBannerImg(Integer bannerId) {
        String nowTime = DateUtils.getDate("yyyy-MM-dd");
        return toBannerMapper.selectByCommunityId(bannerId, nowTime);
    }

    @Override
    public List<ToBanner> viewAllBannerImg() {
        //查询轮播图数量
        Integer bannerNum = tpCarouselSettingMapper.selectCarouselNum(Constant.BANNER);

        String nowTime = DateUtils.getDate("yyyy-MM-dd");
        return toBannerMapper.selectAllByNum(nowTime, bannerNum);
    }
}
