package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.community.commom.ailiyun.AESDecode;
import com.community.commom.constant.Constant;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.common.hk.HKConstant;
import com.community.huiju.common.hk.OpenapiUtil;
import com.community.huiju.controller.ImageController;
import com.community.huiju.dao.TaFaceMapper;
import com.community.huiju.dao.TaSysRoleMapper;
import com.community.huiju.dao.TaUserMapper;
import com.community.huiju.model.TaFace;
import com.community.huiju.model.TaSysRole;
import com.community.huiju.model.TaUser;
import com.community.huiju.service.ImageServiceI;
import com.community.huiju.service.FaceServicel;
import com.hikvision.cms.api.common.util.Digests;
import com.hikvision.cms.api.common.util.HttpClientSSLUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Service
public class FaceServicelimpl implements FaceServicel {


    @Autowired
    private TaFaceMapper taFaceMapper;

    @Autowired
    private TaUserMapper taUserMapper;

    @Autowired
    private TaSysRoleMapper taSysRoleMapper;

    @Autowired
    private ImageServiceI imageServiceI;

    @Override
    public ResponseBean addFace(Integer userid,MultipartFile uploadFile) {
        String faceImg = null;
        try {
            faceImg=imageServiceI.getImageUrl(uploadFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
        TaUser user=taUserMapper.selectByPrimaryKey(userid);
        ResponseBean response = new ResponseBean();
        TaFace taFace = new TaFace();
        taFace.setCommunityId(user.getCommunityId());
        taFace.setTaUserId(userid);
        taFace.setCreateUser(userid);
        taFace.setUpdateUser(userid);
        taFace.setCreateDate(new Date());
        taFace.setUpdateDate(new Date());
        //已登陆，身份未知，状态未知


        //判断身份是否为业主且状态为已停用
        TaSysRole sysRole = taSysRoleMapper.findRoleByUserId(userid);
        TaUser taUser = taUserMapper.selectByPrimaryKey(userid);
        if (Constant.INVALID.equals(taUser.getStatus())
                && Constant.OWNER.equals(sysRole.getRoleName())) {

            response.addError("9996", "您的身份已停用，请联系物业");
            return response;
        }

        //身份为家属租客，状态为已停用
        if (Constant.INVALID.equals(taUser.getStatus())
                && (Constant.RELATION.equals(sysRole.getRoleName())) || Constant.TENANT.equals(sysRole.getRoleName())) {

            response.addError("9996", "您的身份已停用，请联系物业");
            return response;
        }

        //查询当前用户是否有人脸记录
        TaFace User = taFaceMapper.getByUserId(userid);
        if (null == User) {   //为业主，已认证
            boolean isA=true;
            if (Constant.OWNER.equals(sysRole.getRoleName()) && "1".equals(taUser.getVerifyStatus())) {
                ResponseBean responseBean = new ResponseBean();
                boolean resps=checKout(faceImg,taFace,isA,null);
                if (resps==true) {
                    //校验通过后
                    imgPush(user.getUserName(),faceImg);
                    responseBean.addSuccess("图片录入成功");
                }else {
                    responseBean.addError("7771","请录入正确的图片");
                }
                return responseBean;
            }
            //家属或者租客
            if (Constant.RELATION.equals(sysRole.getRoleName()) || Constant.TENANT.equals(sysRole.getDescription()) && "1".equals(taUser.getVerifyStatus())) {
                ResponseBean responseBeans = new ResponseBean();
                boolean resps=checKout(faceImg,taFace,isA,null);
                if (resps==true) {
                    imgPush(user.getUserName(),faceImg);
                    responseBeans.addSuccess("图片录入成功");
                }else {
                    responseBeans.addError("7771","请录入正确的图片");
                }
                return responseBeans;
            }
        } else {
            //为业主，已认证
            if (Constant.OWNER.equals(sysRole.getRoleName()) && "1".equals(taUser.getVerifyStatus())) {
                response.addError("8885", "您的信息已存在");
                return response;
            }
            //家属或者租客
            if (Constant.RELATION.equals(sysRole.getRoleName()) || Constant.TENANT.equals(sysRole.getDescription()) && "1".equals(taUser.getVerifyStatus())) {
                response.addError("8885", "您的信息已存在");
                return response;
            }
        }
        response.addError("9995", "无法确认您的身份，请联系物业");
        return response;


    }

    @Override
    public ResponseBean upDateFace(Integer userId,MultipartFile uploadFile) {
        boolean isA=false;
        String faceImg = null;
        try {
            faceImg=imageServiceI.getImageUrl(uploadFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
        TaUser user=taUserMapper.selectByPrimaryKey(userId);
        ResponseBean responseBean = new ResponseBean();
        TaFace taFace = new TaFace();
        taFace.setCommunityId(user.getCommunityId());
        taFace.setTaUserId(userId);
        taFace.setUpdateUser(userId);
        taFace.setUpdateDate(new Date());
        boolean ck=checKout(faceImg,taFace,isA,userId);
        if (ck == true) {
            responseBean.addSuccess("修改成功");
        }else {
            responseBean.addError("7771","请录入正确图片");
        }
        return responseBean;
    }

    //人脸录入验证
    public boolean checKout(String faceImg, TaFace taFace, boolean isA,Integer user) {
        AESDecode aesd = new AESDecode();
                String body = "{\"type\": \"0\", \"image_url\":\"" + faceImg + "\"}";
        try {
             ResponseBean responseBean = aesd.send(body);
            JSONObject jsonObject = JSONObject.parseObject(responseBean.getMessage());
            Integer type = (Integer) jsonObject.get("errno");
            Integer faceNum= (Integer) jsonObject.get("face_num");
            if (0==type && null!=faceNum && 1==faceNum && isA==true) {
                taFace.setFaceImg(faceImg);
                taFaceMapper.insertSelective(taFace);
                return true;
            }else if (0==type && null!=faceNum && 1==faceNum && isA==false){
                taFace.setFaceImg(faceImg);
                taFaceMapper.updateByPrimaryKeySelective(taFace);
                return true;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }
    //在图片验证通过的情况下，推送到海康
    public Object imgPush(String name,String img){
        String url = HKConstant.OPENAPI_IP_PORT_HTTP + HKConstant.OP_IMG;
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("appkey", HKConstant.APPKEY);//设置APPKEY
        map.put("time", System.currentTimeMillis());//设置时间参数
        map.put("facePhotos", System.currentTimeMillis());//设置时间参数 //bs64转码
        map.put("personName",name);//名字
        map.put("personName",System.currentTimeMillis());//时间取毫秒
        String params =  JSON.toJSONString(map);
        System.out.println(" ====== testGetDefaultUserUUID 请求参数：【" + params + "】");
        String data = null;
        try {
            data = HttpClientSSLUtils.doPost(url + "?token=" + Digests.buildToken(url + "?" + params, params, HKConstant.SECRET), params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println(" ====== testGetDefaultUserUUID 请求返回结果：【{" + data + "}】");
        return data;
    }

}
