package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSON;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.common.hk.HKConstant;
import com.community.huiju.service.IMonitoringService;
import com.google.common.collect.Maps;
import com.hikvision.cms.api.common.util.Digests;
import com.hikvision.cms.api.common.util.HttpClientSSLUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * 监控 业务实现
 * @author weixmei
 */
@Service("iMonitoringService")
@Slf4j
public class MonitoringServiceImpl implements IMonitoringService {

    @Override
    public ResponseBean getByCommunityId(Integer communityId) {

        // TODO 数据是假数据, 后期在更改

        ResponseBean response = new ResponseBean();
        Map<String,Object> parMap = Maps.newHashMap();
        String url = HKConstant.OPENAPI_IP_PORT_HTTP + HKConstant.ITF_ADDRESS_GET_DEFAULT_USER_UUID;
        parMap.put("appkey", HKConstant.APPKEY);//设置APPKEY
        parMap.put("time", System.currentTimeMillis());//设置时间参数
        String params =  JSON.toJSONString(parMap);
        log.info(" ====== testGetDefaultUserUUID 请求参数：【" + params + "】");
        String data = null;
        try {
            data = HttpClientSSLUtils.doPost(url + "?token=" + Digests.buildToken(url + "?" + params, params, HKConstant.SECRET), params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.info(" ====== testGetDefaultUserUUID 请求返回结果：【{" + data + "}】");


        return response;
    }
}
