package com.community.huiju.service.impl;

import com.community.commom.constant.Constant;
import com.community.huiju.dao.TaVisitorLicenseMapper;
import com.community.huiju.dao.TaVisitorMapper;
import com.community.huiju.model.TaVisitor;
import com.community.huiju.model.TaVisitorLicense;
import com.community.huiju.service.TaVistorServiceI;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author weichaochao
 * @Title: TaVistorServiceImpl
 * @Description: 访客实现类
 * @date 2018/11/1
 */
@Service("TaVistorServiceImpl")
public class TaVistorServiceImpl implements TaVistorServiceI {

    @Autowired
    private TaVisitorMapper taVisitorMapper;

    @Autowired
    private TaVisitorLicenseMapper taVisitorLicenseMapper;

    @Override
    public void insertTaVistor(TaVisitor taVisitor, Integer communityId, Integer userId) {

        //todo 推送到海康然后返回给我们一个vistor_code，暂未提供

        taVisitor.setTaUserId(userId);
        taVisitor.setUpdateUser(userId);
        taVisitor.setCreateUser(userId);
        taVisitor.setCreateDate(new Date());
        taVisitor.setUpdateDate(new Date());

        if (Constant.EFFECTIVE.equals(taVisitor.getDrivingStatus())){
            taVisitorMapper.insertSelective(taVisitor);

            for (Integer taCarLicense : taVisitor.getCarLicense()){
                TaVisitorLicense taVisitorLicense = new TaVisitorLicense();
                taVisitorLicense.setCommunityId(communityId);
                taVisitorLicense.setVisitorId(taVisitor.getId());
                taVisitorLicense.setLicense(taCarLicense.toString());
                taVisitorLicense.setCreateUser(userId);
                taVisitorLicense.setCreateDate(new Date());
                taVisitorLicense.setUpdateUser(userId);
                taVisitorLicense.setUpdateDate(new Date());
                taVisitorLicenseMapper.insertSelective(taVisitorLicense);
            }
        } else{
            taVisitorMapper.insertSelective(taVisitor);
        }

    }

    @Override
    public List<TaVisitor> invateHis(Integer communityId, Integer userId) {
        List<TaVisitor> taVisitors = taVisitorMapper.findAllVistors(communityId, userId);

        for (TaVisitor taVisitor : taVisitors){
            if (Constant.EFFECTIVE.equals(taVisitor.getDrivingStatus())){
                List<Integer> taVisitorLicenses = taVisitorLicenseMapper.findTaVistorLicenseById(taVisitor.getId());
                taVisitor.setCarLicense(taVisitorLicenses);
            }
        }
        return taVisitors;
    }
}
