package com.community.huiju.service;

import com.community.commom.mode.ResponseBean;
import com.community.huiju.model.ToBanner;

/**
 * banner 业务管理
 * @author weiximei
 */
public interface IToBannerService {

    /**
     * 添加banner
     * @param banner
     * @param currentUserId
     * @return
     */
    ResponseBean addBanner(ToBanner banner,Integer currentUserId);

    /**
     * 查询banner详情
     * @param bannerId banner的编号
     * @return
     */
    ResponseBean getById(Integer bannerId);

    /**
     * 修改banner
     * @param banner
     * @param currentUserId
     * @return
     */
    ResponseBean modifyBanner(ToBanner banner,Integer currentUserId);

    /**
     * 根据条件查询Banner
     *
     * title 标题
     * bannerDescription 跳转描述
     * bannerPosition banner位
     *
     *
     * @param banner
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseBean getBanner(ToBanner banner, Integer pageNum, Integer pageSize);

    /**
     * 根据bannerId 删除 banner
     * @param bannerId
     * @return
     */
    ResponseBean deleteBanner(Integer bannerId);

}
