import { fetchList, createCommunity, updateCommunity } from '@/api/community'

const community = {
  namespaced: true,
  state: {
    total: '',
    list: [],
    detail: {},
  },

  mutations: {
    SET_LIST: (state, list) => {
      state.list = list
    },
    Insert_LIST: (state, detail) => {
      state.list = [detail, ...list]
    },
    UpdateList: (state, detail) => {
      state.list = state.list.map(item => {
        if (item.id === detail.id) {
          return detail
        }
        return item
      })
    },
    SET_TOTAL: (state, total) => {
      state.total = total
    },
    setDetail: (state, item) => {
      state.detail = item
    },
    resetDetail: (state) => {
      state.detail = {
        ...{
          id: undefined,
          importance: 1,
          remark: '',
          timestamp: new Date(),
          title: '',
          status: 'published',
          type: ''
        }
      }
    }
  },

  actions: {
    // fetchList,获取社区列表
    FetchCommunityList({ commit }, listQuery) {
      return new Promise((resolve, reject) => {
        fetchList(listQuery).then(response => {
          const data = response.data
          commit('SET_LIST', data.items)
          commit('SET_TOTAL', data.total)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    CreateCommunity({ commit }, datail) {
      return new Promise((resolve, reject) => {
        createCommunity(datail).then(response => {
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    UpdateCommunity({ commit }, datail) {
      return new Promise((resolve, reject) => {
        updateCommunity(datail).then(response => {
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    }
  }
}

export default community
